% Manhattan Environment Simulation

close all;
clear all;
clc;

% Constants definition
choise = 0;
possibility = 6;
choise1 = 0;
possibility1 = 5;
choise2 = 0;
possibility2 = 5;
choise3 = 0;
possibility3 = 5;
choise4 = 0;
possibility4 = 5;
m_UE_vel_kmph=3;
lines = 1;
W = 3840000;
BS_power_1=0;
Pn_1=0;
Pc_1=0;
p_1=0;
m_building_number_x=12;
m_building_number_y=12;
building_number_x=12;
building_number_y=12;
m_UE_num = 5;
m_BS_power_oth = 2;
m_UE_Eb_No_dB = 5;
m_UE_Rb_kbps = 64;
m_p_cell = 0.1;
m_Pn_cell = 10^(-13);
m_Pc_cell = 0.1;
m_UE_vel_kmph=3;
m_aviname='my_video.avi';
mov_UE_pos(1,1)=367.5;
mov_UE_pos(1,2)=547.5;
mov_UE_num = 1;
circle_radius=90;
circle_center=[547.5 547.5];
t = 0:pi/50:10*pi;


%**************************************************************************
% Create main menu*********************************************************
%**************************************************************************
choise=0;
while choise ~= possibility,
    choise = menu('Manhattan Environment Simulation',...
        '1. Manhattan Environment Building Set up',...
        '2. Define Topology Parameters',...
        '3. Define User Parameters',...
        'Help (Adobe Acrobat required)',...
        ' Credits ',...
        'Close Program');
    %     '3. BS total transmission power vs No of UEs',...
    %     '4. BS total transmission power vs Bit Rate',...
    %     '5. BS total transmission power vs Moving UEs',...
    %     '3. Independent UEs',...


%**************************************************************************
%**************************************************************************
    % Manhattan Environment Sim (choise == 1)******************************
    if choise == 1,

        building_number_xx = char(strcat({' Number of buildings in x-direction'}));
        building_number_yy = char(strcat({' Number of buildings in y-direction'}));
        prompt = {building_number_xx,building_number_yy};
        title  = 'Building Number Specification';
        def    = {num2str(m_building_number_x),num2str(m_building_number_y)};
        answer = inputdlg(prompt,title,lines,def);
        building_number_x = str2num(char(answer(1)));
        if (isempty(building_number_x)) building_number_x=m_building_number_x; end
        building_number_y = str2num(char(answer(2)));
        if (isempty(building_number_y)) building_number_y=m_building_number_y; end
        Waiting = waitbar(0,'Calculations in progress, please wait...');
        for i=1:100, % computation here %
            waitbar(i/100)
        end
        [BS_total]=manhattan_env2(building_number_x, building_number_y);
        close(Waiting)

    end


%**************************************************************************
%**************************************************************************
    % Define Topology Parameters (choise == 2)*****************************
    if choise == 2,
        close all

        BS_power_1=0;Pn_1=0;Pc_1=0;p_1=0;
        BS_power_oth = char(strcat({' Other BSs transmitted power (Watt)'}));
        Pn_cell = char(strcat({' Background noise (Watt)' }));
        Pc_cell = char(strcat({' Common Control Channel power (Watt)'}));
        p_cell = char(strcat({' Orthogonallity factor (0 for fully orthogonal codes)'}));

        prompt = {BS_power_oth,Pn_cell,Pc_cell,p_cell};
        title  = 'Define Topology Parameters';
        def    = {num2str(m_BS_power_oth),num2str(m_Pn_cell),...
            num2str(m_Pc_cell),num2str(m_p_cell)};
        answer = inputdlg(prompt,title,lines,def);
        BS_power_1 = str2num(char(answer(1)));
        if (isempty(BS_power_1)) BS_power_1=m_BS_power_oth; end
        Pn_1 = str2num(char(answer(2)));
        if (isempty(Pn_1)) Pn_1=m_Pn_cell; end
        Pc_1 = str2num(char(answer(3)));
        if (isempty(Pc_1)) Pc_1=m_Pc_cell; end
        p_1 = str2num(char(answer(4)));
        if (isempty(p_1)) p_1=m_p_cell; end

        % Base Station Topology
        Waiting = waitbar(0,'Calculations in progress, please wait...');
        for i=1:100, % computation here %
            waitbar(i/100)
        end
        [BS_total]=manhattan_env2(building_number_x, building_number_y);
        [BS_num,n] = size(BS_total);
        hold on
        plot(BS_total(:,1),BS_total(:,2),'*');
        legend('Node B');

%         % Parameters Display
%         Display_message = char(strcat({'--------------------------------------',...
%             'Inserted Topology Parameters',...
%             '--------------------------------------',...
%             'You have made the following choices:','',...
%             'Other BSs transmitted power (Watt):',num2str(BS_power),...
%             'Background noise (Watt):',num2str(Pn),...
%             'Common Control Channel power (Watt):',num2str(Pc),...
%             'Orthogonallity factor:',num2str(p),'',''}));
%         msgbox(Display_message,'Topology Parameters Display');
        close(Waiting)
    end


%**************************************************************************
%**************************************************************************
    % Define User Parameters (choise == 3)*********************************
    if choise == 3,
        close all

        num=0;Eb_No_dB=0;Rb_kbps=0;Eb_No=0;Rb=0;
        if BS_power_1==0 BS_power=m_BS_power_oth;
        else BS_power=BS_power_1;
        end
        if Pn_1==0 Pn=m_Pn_cell;
        else Pn=Pn_1;
        end
        if Pc_1==0 Pc=m_Pc_cell;
        else Pc=Pc_1;
        end
        if p_1==0 p=m_p_cell;
        else p=p_1;
        end
        UE_num = char(strcat({' Number of UEs'}));
        UE_Eb_No_dB = char(strcat({' Eb/No (dB) for all UEs'}));
        UE_Rb_kbps = char(strcat({' Bit rate (kbps) for all UEs'}));

        prompt = {UE_num,UE_Eb_No_dB,UE_Rb_kbps};
        title  = 'Define User Parameters';
        def    = {num2str(m_UE_num),num2str(m_UE_Eb_No_dB),...
            num2str(m_UE_Rb_kbps)};
        answer = inputdlg(prompt,title,lines,def);
        num = str2num(char(answer(1)));
        if (isempty(num)) num=m_UE_num; end
        Eb_No_dB = str2num(char(answer(2)));
        if (isempty(Eb_No_dB)) Eb_No_dB=m_UE_Eb_No_dB; end
        Rb_kbps = str2num(char(answer(3)));
        if (isempty(Rb_kbps)) Rb_kbps=m_UE_Rb_kbps; end
        Eb_No=10^(Eb_No_dB/10);
        Rb=1000*Rb_kbps;

%         Display_message = char(strcat({'--------------------------------------',...
%             'Inserted User Parameters','--------------------------------------',...
%             'You have made the following choices:','',...
%             'Number of UEs:',num2str(num),...
%             'Eb/No (dB):',num2str(Eb_No_dB),...
%             'Bit rate (kbps):',num2str(Rb_kbps)}));
%         msgbox(Display_message,'User Parameters Display');

%**************************************************************************
        % Create submenu (Static Users)************************************
        choise1=0;
        while choise1 ~= possibility1,
            choise1 = menu('UEs Topology',...
                '1. Group of UEs in the same spot',...
                '2. UEs with random coordinates',...
                '3. UEs with random coordinates and moving UE',...
                'Help (Adobe Acrobat required)',...
                'Close Submenu');

% *************************************************************************
        % Define Group Coordinates (choise1 == 1)**************************
            if choise1 == 1,
                close all
                
                % Base Station Topology
                [BS_total]=manhattan_env2(building_number_x, building_number_y);
                [BS_num,n] = size(BS_total);
                hold on
                plot(BS_total(:,1),BS_total(:,2),'b*');
                hold on
                fnplt(fncmb(rsmak('circle',circle_radius,circle_center)));
                legend('Node B','Examined area');
                zoom(2);
                text(530,320,...
                    'Note: One left click defines the Group location',...
                    'BackgroundColor',[.7 .9 .7]);
                UE_pos=zeros(1,2);
                [UE_pos(1,1),UE_pos(1,2)] = ginput(1);

        %******************************************************************
        % Create submenu (Static Users)************************************
                choise2=0;
                while choise2 ~= possibility2,
                    choise2 = menu('Static Users',...
                        '1. BS power vs No of UEs',...
                        '2. BS power vs Bit Rate',...
                        '3. BS power vs Eb/No',...
                        'Help (Adobe Acrobat required)',...
                        'Close Submenu');

        %******************************************************************
        % Static Users --> BS power vs No of UEs (choise2 == 1)************
                    if choise2 == 1,
                        close all

                        % Set matrices to zero
                        Pt=0;Lpi=0;Lpi_dB=0;Pt_UE=0;Pt_rb=0;
                        distance=0;p1=0;p2=0;xi=0;ii=0;
                        % Base Station Topology
                        Waiting = waitbar(0,'Calculations in progress, please wait...');
                        for i=1:100, % computation here %
                            waitbar(i/100)
                        end
                        [BS_total]=manhattan_env2(building_number_x, building_number_y);
                        [BS_num,n] = size(BS_total);
                        hold on

                        % Evaluation of UE-BS distance (in meters)
                        for j=1:BS_num  % BS_num = number of all BSs
                            distance(j,1)=sqrt((BS_total(j,1)-UE_pos(1,1)).^2+(BS_total(j,2)-UE_pos(1,2)).^2);
                        end

                        % Total Path Loss Evaluation
                        for j=1:BS_num  % BS_num = number of all BSs
                            Lpi_dB(j,1)=24+45*log10(distance(j,1)+20);
                            Lpi(j,1)=10^(Lpi_dB(j,1)/10);
                        end

                        % Path Loss from active BS (closest to UE)
                        [Lpi_act,BS_act]=min(Lpi);
                        plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                            BS_total(:,1),BS_total(:,2),'b*',UE_pos(1,1),UE_pos(1,2),'ro',...
                            BS_total(BS_act,1),BS_total(BS_act,2),'*g');
                        legend('Examined area','Node B','UE Group','Examined Node B');

                        % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                        % from RRM strategies p.143 (162)
                        % Ptj = Transmission power of the jth BS in Watt
                        % Lij = Path Loss to UE i from jth BS
                        for j=1:BS_num  % BS_num = number of all BSs
                            xi(j,1)=BS_power/Lpi(j,1);
                        end
                        xi_tot=sum(xi)-xi(BS_act,1);

                        % From RRM strategies p.141 (160)
                        % Calculation of: [W/(Eb/No*Rb)]+p
                        p1 = W/(Eb_No*Rb) + p;

                        % Calculation of: ((Pn+xi)/((W/(Eb/No*Rb))+p))*Lpi
                        % Lpi = Path Loss from active BS (closest to UE)
                        % xi = Intercell Interference from other cells
                        p2 = (Pn+xi_tot)*Lpi_act/p1;

                        % Calculation of total transmitted power vs No of UEs
                        figure('Name','BS total transmission power vs No of UEs');
                        for i=1:num
                            Pt(i) = (Pc+i*p2)/(1-i*p/p1);
                            ii(i) = i;
                        end
                        plot(ii,Pt,'-*')
                        xlabel('UEs Number'); ylabel('Total Power (W)');
                        grid;

                        Pt_UE = ones(2,num);
                        Pt_UE(1,:) = (1:num);
                        Pt_UE(2,:) = Pt(1:num);

                        % Parameters Display
                        Display_message = char(strcat({'--------------------------------------',...
                            'Input Parameters','--------------------------------------',...
                            'You have made the following choices:','',...
                            'Number of UEs in group:',num2str(num),'Other BSs transmitted power (Watt):',...
                            num2str(BS_power),'Background noise (Watt):',num2str(Pn),...
                            'Common Control Channel power (Watt):',num2str(Pc),'Eb/No (dB):',...
                            num2str(Eb_No_dB),'Bit rate (kbps):',num2str(Rb_kbps),...
                            'Group Position in x-direction (m):',num2str(UE_pos(1,1)),...
                            'Group Position in y-direction (m):',num2str(UE_pos(1,2)),...
                            'Orthogonallity factor:',num2str(p),'','',...
                            '--------------------------------------','Results',...
                            '--------------------------------------',...
                            'For the selected values of parameters:',...
                            'UE No vs Total transmitted power of active BS','',...
                            'No    (Watt)','---    -----------',num2str(Pt_UE'),'',...
                            '--------------------------------------','','',...
                            'Note: The power is calculated every time after',...
                            '        increasing the No of UEs by 1',''}));
                        msgbox(Display_message,'Parameters And Results Display');
                        close(Waiting)

                    end

        %******************************************************************
        % Static Users --> BS power vs Bit Rate (choise2 == 2)*************
                    if choise2 == 2,
                        close all

                        % Set matrices to zero
                        Rb_kbps1=64;Pt=0;Lpi=0;Lpi_dB=0;Pt_rb=0;
                        distance=0;p1=0;p2=0;xi=0;
                        Rb1=1000*Rb_kbps1;
                        % Base Station Topology
                        Waiting = waitbar(0,'Calculations in progress, please wait...');
                        for i=1:100, % computation here %
                            waitbar(i/100)
                        end
                        [BS_total]=manhattan_env2(building_number_x, building_number_y);
                        [BS_num,n] = size(BS_total);
                        hold on

                        % Evaluation of UE-BS distance (in meters)
                        for j=1:BS_num  % BS_num = number of all BSs
                            distance(j,1)=sqrt((BS_total(j,1)-UE_pos(1,1)).^2+(BS_total(j,2)-UE_pos(1,2)).^2);
                        end

                        % Total Path Loss Evaluation
                        for j=1:BS_num  % BS_num = number of all BSs
                            Lpi_dB(j,1)=24+45*log10(distance(j,1)+20);
                            Lpi(j,1)=10^(Lpi_dB(j,1)/10);
                        end

                        % Path Loss from active BS (closest to UE)
                        [Lpi_act,BS_act]=min(Lpi);
                        plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                            BS_total(:,1),BS_total(:,2),'b*',UE_pos(1,1),UE_pos(1,2),'ro',...
                            BS_total(BS_act,1),BS_total(BS_act,2),'*g');
                        legend('Examined area','Node B','UE Group','Examined Node B');

                        % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                        % from RRM strategies p.143 (162)
                        % Ptj = Transmission power of the jth BS in Watt
                        % Lij = Path Loss to UE i from jth BS
                        for j=1:BS_num  % BS_num = number of all BSs
                            xi(j,1)=BS_power/Lpi(j,1);
                        end
                        xi_tot=sum(xi)-xi(BS_act,1);

                        % From RRM strategies p.141 (160)
                        % Calculation of: [W/(Eb/No*Rb)]+p

                        figure('Name','BS total transmission power vs Bit Rate for n UEs');
                        for rb=1:6
                            p1(rb) = W/(Eb_No*rb*Rb1) + p;
                            % Calculation of: ((Pn+xi)/((W/(Eb/No*Rb))+p))*Lpi
                            % Lpi = Path Loss from active BS (closest to UE)
                            % xi = Intercell Interference from other cells
                            p2(rb) = (Pn+xi_tot)*Lpi_act/p1(rb);
                            rbb(rb)=rb;
                            % Calculation of total transmitted power
                            Pt(rb) = (Pc+num*p2(rb))/(1-num*p/p1(rb));
                        end
                        plot(rbb*Rb1/1000,Pt,'-*')
                        xlabel('Bit Rate (kbps)'); ylabel('Total Power (W)');
                        grid;

                        Pt_rb = ones(2,rb);
                        Pt_rb(1,:) = (1:rb)*Rb1/1000;
                        Pt_rb(2,:) = Pt(1:rb);

                        % Parameters Display
                        Display_message = char(strcat({'--------------------------------------',...
                            'Input Parameters','--------------------------------------',...
                            'You have made the following choices:','',...
                            'Number of UEs in group:',num2str(num),'Other BSs transmitted power (Watt):',...
                            num2str(BS_power),'Background noise (Watt):',num2str(Pn),...
                            'Common Control Channel power (Watt):',num2str(Pc),'Eb/No (dB):',...
                            num2str(Eb_No_dB),...
                            'Group Position in x-direction (m):',num2str(UE_pos(1,1)),...
                            'Group Position in y-direction (m):',num2str(UE_pos(1,2)),...
                            'Orthogonallity factor:',num2str(p),'','',...
                            '--------------------------------------','Results',...
                            '--------------------------------------',...
                            'For the selected values of parameters:',...
                            'Bit Rate vs Total transmitted power of active BS','',...
                            '(kbps)     (Watt)','----------    -----------',num2str(Pt_rb'),'',...
                            '--------------------------------------','','',...
                            'Note: The power is calculated every time after',...
                            '        assuming that all the UEs in the group',...
                            '        have the same Bit Rate',''}));
                        msgbox(Display_message,'Parameters and Results Display');
                        close(Waiting)
                    end;

        %******************************************************************
        % Static Users --> BS power vs Eb/No (choise2 == 3)****************
                    if choise2 == 3,
                        close all

                        % Set matrices to zero
                        Pt=0;Lpi=0;Lpi_dB=0;Pt_rb=0;
                        distance=0;p1=0;p2=0;xi=0;
                        Waiting = waitbar(0,'Calculations in progress, please wait...');
                        for i=1:100, % computation here %
                            waitbar(i/100)
                        end
                        Eb_No_dB1=[3 4 5 5.5 6 6.5 7 8];
                        for rb=1:8
                            Eb_No1(1,rb)=10^(Eb_No_dB1(1,rb)/10);
                        end
                        % Base Station Topology
                        [BS_total]=manhattan_env2(building_number_x, building_number_y);
                        [BS_num,n] = size(BS_total);
                        hold on

                        % Evaluation of UE-BS distance (in meters)
                        for j=1:BS_num  % BS_num = number of all BSs
                            distance(j,1)=sqrt((BS_total(j,1)-UE_pos(1,1)).^2+(BS_total(j,2)-UE_pos(1,2)).^2);
                        end

                        % Total Path Loss Evaluation
                        for j=1:BS_num  % BS_num = number of all BSs
                            Lpi_dB(j,1)=24+45*log10(distance(j,1)+20);
                            Lpi(j,1)=10^(Lpi_dB(j,1)/10);
                        end

                        % Path Loss from active BS (closest to UE)
                        [Lpi_act,BS_act]=min(Lpi);
                        plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                            BS_total(:,1),BS_total(:,2),'b*',UE_pos(1,1),UE_pos(1,2),'ro',...
                            BS_total(BS_act,1),BS_total(BS_act,2),'*g');
                        legend('Examined area','Node B','UE Group','Examined Node B');

                        % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                        % from RRM strategies p.143 (162)
                        % Ptj = Transmission power of the jth BS in Watt
                        % Lij = Path Loss to UE i from jth BS
                        for j=1:BS_num  % BS_num = number of all BSs
                            xi(j,1)=BS_power/Lpi(j,1);
                        end
                        xi_tot=sum(xi)-xi(BS_act,1);

                        % From RRM strategies p.141 (160)
                        % Calculation of: [W/(Eb/No*Rb)]+p

                        figure('Name','BS total transmission power vs Eb/No for n UEs');
                        for rb=1:8
                            p1(rb) = W/(Eb_No1(rb)*Rb) + p;
                            % Calculation of: ((Pn+xi)/((W/(Eb/No*Rb))+p))*Lpi
                            % Lpi = Path Loss from active BS (closest to UE)
                            % xi = Intercell Interference from other cells
                            p2(rb) = (Pn+xi_tot)*Lpi_act/p1(rb);
                            % Calculation of total transmitted power
                            Pt(rb) = (Pc+num*p2(rb))/(1-num*p/p1(rb));
                        end
                        plot(10*log10(Eb_No1),Pt,'-*')
                        xlabel('Eb/No (dB)'); ylabel('Total Power (W)');
                        grid;

                        Pt_rb = ones(2,rb);
                        Pt_rb(1,:) = 10*log10(Eb_No1);
                        Pt_rb(2,:) = Pt;

                        % Parameters Display
                        Display_message = char(strcat({'--------------------------------------',...
                            'Input Parameters','--------------------------------------',...
                            'You have made the following choices:','',...
                            'Number of UEs in group:',num2str(num),'Other BSs transmitted power (Watt):',...
                            num2str(BS_power),'Background noise (Watt):',num2str(Pn),...
                            'Common Control Channel power (Watt):',num2str(Pc),...
                            'Bit rate (kbps):',num2str(Rb_kbps),...
                            'Group Position in x-direction (m):',num2str(UE_pos(1,1)),...
                            'Group Position in y-direction (m):',num2str(UE_pos(1,2)),...
                            'Orthogonallity factor:',num2str(p),'','',...
                            '--------------------------------------','Results',...
                            '--------------------------------------',...
                            'For the selected values of parameters:',...
                            'Eb/No vs Total transmitted power of active BS','',...
                            '(dB)      (Watt)','----------    -----------',num2str(Pt_rb'),'',...
                            '--------------------------------------','','',...
                            'Note: The power is calculated every time after',...
                            '        assuming that all the UEs in the group',...
                            '        have the same Eb/No requirements',''}));
                        msgbox(Display_message,'Parameters and Results Display');
                        close(Waiting)
                    end;

        %******************************************************************
        % Help Window (choise2 == 4)***************************************
                    if choise2 == 4,
                        clc;
                        close all;
                        open('Help_3.pdf');
                    end;

        %******************************************************************
        % Close Submenu (choise2 == 5)*************************************
                    if choise2 == possibility2
                        close all;
                    end;

                end;
            end;

% *************************************************************************
        % Define Each UE Coordinates (choise1 == 2)************************
            if choise1 == 2,
                close all
                
                % Base Station Topology
                UE_pos_mul=zeros(num,2);
                UE_pos_x=zeros(num,1);
                UE_pos_y=zeros(num,2);
                [BS_total]=manhattan_env2(building_number_x, building_number_y);
                [BS_num,n] = size(BS_total);
                hold on
                plot(BS_total(:,1),BS_total(:,2),'b*');
                hold on
                fnplt(fncmb(rsmak('circle',circle_radius,circle_center)));
                legend('Node B','Examined area');
                zoom(2);
                Display_message = char(strcat({'Note: Each click defines the location of each UE',...
                    strcat('        Total clicks allowed (ie. UEs number):  ',num2str(num))}));
                text(510,330,...
                    circle_center(1,2)-1.6*circle_radius,...
                    Display_message,...
                    'BackgroundColor',[.7 .9 .7]);
                [UE_pos_x,UE_pos_y] = ginput(num);
                UE_pos_mul(:,1) = UE_pos_x;
                UE_pos_mul(:,2) = UE_pos_y;

        %******************************************************************
        % Create submenu (Random Users)************************************
                choise3=0;
                while choise3 ~= possibility3,
                    choise3 = menu('Random Users',...
                        '1. BS total Power',...
                        '2. BS power vs Bit Rate',...
                        '3. BS power vs Eb/No',...
                        'Help (Adobe Acrobat required)',...
                        'Close Submenu');

        %******************************************************************
        % BS total Power (choise3 == 1)************************************
                    if choise3 == 1,
                        close all;
                        
                        Pt=0;Lpi=0;Lpi_dB=0;distance=0;p1_split=0;p2_split=0;xi=0;
                        BS_UE=0;p1_split_tot=0;p2_split_tot=0;p3_split_tot=0;
                        Waiting = waitbar(0,'Calculations in progress, please wait...');
                        for i=1:100, % computation here %
                            waitbar(i/100)
                        end
                        [BS_total]=manhattan_env2(building_number_x, building_number_y);
                        [BS_num,n] = size(BS_total);
                        hold on

                        % Evaluation of UE-BS distance (in meters)
                        for i=1:num         % num = number of all UEs
                            for j=1:BS_num  % BS_num = number of all BSs
                                distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                            end
                        end

                        % Total Path Loss Evaluation
                        for i=1:num
                            for j=1:BS_num  % BS_num = number of all BSs
                                Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                            end
                        end

                        % Path Loss from active BS (closest to UE)
                        for i=1:num         % num = number of all UEs
                            [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                        end

                        plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                            BS_total(:,1),BS_total(:,2),'b*',UE_pos_mul(:,1),UE_pos_mul(:,2),'r.',...
                            BS_total(BS_act,1),BS_total(BS_act,2),'*g');
                        legend('Examined area','Node B','UE','Examined Node B');

                        for i=1:num
                            for j=1:BS_num  % BS_num = number of all BSs
                                xi(j,i)=BS_power/Lpi(j,i);
                            end
                        end

                        for i=1:num         % num = number of all UEs
                            xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                        end

                        BS_UE = ones([num 2]);
                        for i=1:num         % num = number of all UEs
                            BS_UE(i,1) = i;
                            BS_UE(i,2) = BS_act(i);
                        end

                        p1_split=zeros(BS_num,num);
                        for j=1:BS_num      % BS_num = number of all BSs
                            for i=1:num % num = number of all UEs
                                if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                    p1_split(j,i) = W/(Eb_No*Rb) + p;
                                else p1_split(j,i) = 0;
                                end
                            end
                        end

                        p2_split=zeros(BS_num,num);
                        for j=1:BS_num      % BS_num = number of all BSs
                            for i=1:num % num = number of all UEs
                                if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                    p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                else p2_split(j,i) = 0;
                                end
                            end
                        end

                        p3_split=zeros(BS_num,num);
                        for j=1:BS_num      % BS_num = number of all BSs
                            for i=1:num % num = number of all UEs
                                if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                    p3_split(j,i) = p/p1_split(j,i);
                                else p2_split(j,i) = 0;
                                end
                            end
                        end

                        p1_split_tot=(max(p1_split'));
                        p2_split_tot=(sum(p2_split'));
                        p3_split_tot=(sum(p3_split'));

                        Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                        
                        % Parameters Display
                        Display_message = char(strcat({'--------------------------------------',...
                            'Input Parameters','--------------------------------------',...
                            'You have made the following choices:','',...
                            'Number of UEs:',num2str(num),'Other BSs transmitted power (Watt):',...
                            num2str(BS_power),'Background noise (Watt):',num2str(Pn),...
                            'Common Control Channel power (Watt):',num2str(Pc),...
                            'Bit rate (kbps):',num2str(Rb_kbps),...
                            'UEs Position (m):','(Specified by user)',...
                            'Orthogonallity factor:',num2str(p),'','',...
                            '--------------------------------------','Results',...
                            '--------------------------------------',...
                            'For the selected values of parameters:',...
                            'Active BS total transmitted power (Watt)',...
                            num2str(Pt(BS_act(1))),'',...
                            '--------------------------------------'}));
                        msgbox(Display_message,'Parameters and Results Display');
                        close(Waiting)
                    end;

        %******************************************************************
        % BS power vs Bit Rate (choise3 == 2)******************************
                    if choise3 == 2,
                        close all;

                        Rb_kbps1=64;Rb1=1000*Rb_kbps1;Pt_total=0;
                        Pt=0;Lpi=0;Lpi_dB=0;distance=0;p1_split=0;p2_split=0;xi=0;
                        BS_UE=0;p1_split_tot=0;p2_split_tot=0;p3_split_tot=0;
                        Waiting = waitbar(0,'Calculations in progress, please wait...');
                        for i=1:100, % computation here %
                            waitbar(i/100)
                        end
                        [BS_total]=manhattan_env2(building_number_x, building_number_y);
                        [BS_num,n] = size(BS_total);
                        hold on

                        % Evaluation of UE-BS distance (in meters)
                        for i=1:num         % num = number of all UEs
                            for j=1:BS_num  % BS_num = number of all BSs
                                distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                            end
                        end

                        % Total Path Loss Evaluation
                        for i=1:num
                            for j=1:BS_num  % BS_num = number of all BSs
                                Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                            end
                        end

                        % Path Loss from active BS (closest to UE)
                        for i=1:num         % num = number of all UEs
                            [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                        end

                        plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                            BS_total(:,1),BS_total(:,2),'b*',UE_pos_mul(:,1),UE_pos_mul(:,2),'r.',...
                            BS_total(BS_act,1),BS_total(BS_act,2),'*g');
                        legend('Examined area','Node B','UE','Examined Node B');

                        for i=1:num
                            for j=1:BS_num  % BS_num = number of all BSs
                                xi(j,i)=BS_power/Lpi(j,i);
                            end
                        end

                        for i=1:num         % num = number of all UEs
                            xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                        end

                        BS_UE = ones([num 2]);
                        for i=1:num         % num = number of all UEs
                            BS_UE(i,1) = i;
                            BS_UE(i,2) = BS_act(i);
                        end

                        for rb=1:6
                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No*rb*Rb1) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end


                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end


                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end


                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(rb)=(max(Pt'));
                            rbb(rb)=rb;
                        end
                        figure('Name','BS total transmission power vs Bit Rate');
                        plot(rbb*Rb1/1000,Pt_total,'-*')
                        xlabel('Bit Rate (kbps)'); ylabel('Total Power (W)');
                        grid;
                        Pt_rb = ones(2,rb);
                        Pt_rb(1,:) = (1:rb)*Rb1/1000;
                        Pt_rb(2,:) = Pt_total(1:rb);

                        % Parameters Display
                        Display_message = char(strcat({'--------------------------------------',...
                            'Input Parameters','--------------------------------------',...
                            'You have made the following choices:','',...
                            'Number of UEs:',num2str(num),'Other BSs transmitted power (Watt):',...
                            num2str(BS_power),'Background noise (Watt):',num2str(Pn),...
                            'Common Control Channel power (Watt):',num2str(Pc),'Eb/No (dB):',...
                            num2str(Eb_No_dB),...
                            'UEs Position (m):','(Specified by user)',...
                            'Orthogonallity factor:',num2str(p),'','',...
                            '--------------------------------------','Results',...
                            '--------------------------------------',...
                            'For the selected values of parameters:',...
                            'Bit Rate vs Total transmitted power of active BS','',...
                            '(kbps)     (Watt)','----------    -----------',num2str(Pt_rb'),'',...
                            '--------------------------------------','','',...
                            'Note: The power is calculated every time after',...
                            '        assuming that all the UEs in the group',...
                            '        have the same Bit Rate',''}));
                        msgbox(Display_message,'Parameters and Results Display');
                        close(Waiting)
                    end;

        %******************************************************************
        % BS power vs Eb/No (choise3 == 3)*********************************
                    if choise3 == 3,
                        close all;
                        
                        Pt=0;Lpi=0;Lpi_dB=0;distance=0;p1_split=0;p2_split=0;xi=0;
                        BS_UE=0;p1_split_tot=0;p2_split_tot=0;p3_split_tot=0;
                        Pt_total=0;
                        Waiting = waitbar(0,'Calculations in progress, please wait...');
                        for i=1:100, % computation here %
                            waitbar(i/100)
                        end
                        Eb_No_dB1=[3 4 5 5.5 6 6.5 7 8];
                        for rb=1:8
                            Eb_No1(1,rb)=10^(Eb_No_dB1(1,rb)/10);
                        end
                        [BS_total]=manhattan_env2(building_number_x, building_number_y);
                        [BS_num,n] = size(BS_total);
                        hold on

                        % Evaluation of UE-BS distance (in meters)
                        for i=1:num         % num = number of all UEs
                            for j=1:BS_num  % BS_num = number of all BSs
                                distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                            end
                        end

                        % Total Path Loss Evaluation
                        for i=1:num
                            for j=1:BS_num  % BS_num = number of all BSs
                                Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                            end
                        end

                        % Path Loss from active BS (closest to UE)
                        for i=1:num         % num = number of all UEs
                            [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                        end

                        plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                            BS_total(:,1),BS_total(:,2),'b*',UE_pos_mul(:,1),UE_pos_mul(:,2),'r.',...
                            BS_total(BS_act,1),BS_total(BS_act,2),'*g');
                        legend('Examined area','Node B','UE','Examined Node B');

                        for i=1:num
                            for j=1:BS_num  % BS_num = number of all BSs
                                xi(j,i)=BS_power/Lpi(j,i);
                            end
                        end

                        for i=1:num         % num = number of all UEs
                            xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                        end

                        BS_UE = ones([num 2]);
                        for i=1:num         % num = number of all UEs
                            BS_UE(i,1) = i;
                            BS_UE(i,2) = BS_act(i);
                        end

                        for rb=1:8
                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No1(rb)*Rb) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end


                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end


                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end


                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(rb)=(max(Pt'));
                        end

                        figure('Name','BS total transmission power vs Eb/No');
                        plot(10*log10(Eb_No1),Pt_total,'-*')
                        xlabel('Eb/No (dB)'); ylabel('Total Power (W)');
                        grid;

                        Pt_rb = ones(2,rb);
                        Pt_rb(1,:) = 10*log10(Eb_No1);
                        Pt_rb(2,:) = Pt_total(1:rb);
                        
                        % Parameters Display
                        Display_message = char(strcat({'--------------------------------------',...
                            'Input Parameters','--------------------------------------',...
                            'You have made the following choices:','',...
                            'Number of UEs:',num2str(num),'Other BSs transmitted power (Watt):',...
                            num2str(BS_power),'Background noise (Watt):',num2str(Pn),...
                            'Common Control Channel power (Watt):',num2str(Pc),'Eb/No (dB):',...
                            num2str(Eb_No_dB),...
                            'UEs Position (m):','(Specified by user)',...
                            'Orthogonallity factor:',num2str(p),'','',...
                            '--------------------------------------','Results',...
                            '--------------------------------------',...
                            'For the selected values of parameters:',...
                            'Eb/No vs Total transmitted power of active BS','',...
                            '(dB)      (Watt)','----------    -----------',num2str(Pt_rb'),'',...
                            '--------------------------------------','','',...
                            'Note: The power is calculated every time after',...
                            '        assuming that all the UEs in the group',...
                            '        have the same Bit Rate',''}));
                        msgbox(Display_message,'Parameters and Results Display');
                        close(Waiting)
                    end;

        %******************************************************************
        % Help Window (choise3 == 4)***************************************
                    if choise3 == 4,
                        clc;
                        close all;
                        open('Help_4.pdf');
                    end;

        %******************************************************************
        % Close Submenu (choise3 == 5)*************************************
                    if choise3 == possibility3
                        close all;
                    end;

                end;
            end;

% *************************************************************************
        % Define Each Static UE Coordinates (choise1 == 3)*****************
            if choise1 == 3,
                close all

                % Base Station Topology
                UE_pos_mul=zeros(num,2);
                UE_pos_x=zeros(num-1,1);
                UE_pos_y=zeros(num-1,2);
                route_x=0;
                route_y=0;
                [BS_total]=manhattan_env2(building_number_x, building_number_y);
                [BS_num,n] = size(BS_total);
                hold on
                plot(BS_total(:,1),BS_total(:,2),'b*');
                hold on
                route_x=mov_UE_pos(1,1):mov_UE_pos(1,1)+360;
                route_y=mov_UE_pos(1,2);
                fnplt(fncmb(rsmak('circle',circle_radius,circle_center)));
                line(route_x,route_y,'Color',[0 0.6 0.6]);
                hold on
                route_x=mov_UE_pos(1,1)+360;
                route_y=mov_UE_pos(1,2):mov_UE_pos(1,2)+180;
                line(route_x,route_y,'Color',[0 0.6 0.6]);
                hold on
                route_x=mov_UE_pos(1,1)+180:mov_UE_pos(1,1)+360;
                route_y=mov_UE_pos(1,2)+180;
                line(route_x,route_y,'Color',[0 0.6 0.6]);
                hold on
                route_x=mov_UE_pos(1,1)+180;
                route_y=mov_UE_pos(1,2)-180:mov_UE_pos(1,2)+180;
                line(route_x,route_y,'Color',[0 0.6 0.6]);
                legend('Node B','Examined area','Moving UE''s route');
                %zoom(2);
                Display_message = char(strcat({'Note: Each click defines the location of each static UE',...
                    strcat('        Total clicks allowed (ie. static UEs number):  ',num2str(num-1))}));
                text(210,70,...
                    Display_message,...
                    'BackgroundColor',[.7 .9 .7]);
                [UE_pos_x,UE_pos_y] = ginput(num-1);
                UE_pos_mul(1:(num-1),1) = UE_pos_x;
                UE_pos_mul(1:(num-1),2) = UE_pos_y;

                UE_vel_kmph = char(strcat({' Moving UE''s Velocity (km/h)'}));
                UE_Eb_No_dB_mov = char(strcat({' Eb/No (dB) for all UEs'}));
                prompt = {UE_vel_kmph,UE_Eb_No_dB_mov};
                title  = 'Moving UE: Paramaters Specification';
                def    = {num2str(m_UE_vel_kmph),num2str(m_UE_Eb_No_dB)};
                answer = inputdlg(prompt,title,lines,def);
                UE_vel = str2num(char(answer(1)));
                if (isempty(UE_vel)) UE_vel=num2str(m_UE_vel_kmph); end
                Eb_No_dB_mov = str2num(char(answer(2)));
                if (isempty(Eb_No_dB_mov)) Eb_No_dB_mov=m_UE_Eb_No_dB; end
                Eb_No_mov=10^(Eb_No_dB_mov/10);
                UE_vel_mps=UE_vel*(1000/3600);

        %******************************************************************
        % Create submenu (Random Users and moving UE)**********************
                choise4=0;
                while choise4 ~= possibility4,
                    choise4 = menu('Random Users and moving UE',...
                        '1. Examined BS total Power',...
                        '2. Moving UE''s Active BS total power',...
                        '3. Video Creation for Specified Topology',...
                        'Help (Adobe Acrobat required)',...
                        'Close Submenu');
                    
        %******************************************************************
        % Examined BS total Power (choise4 == 1)***************************
                    if choise4 == 1,
                        close all

                        Pt=0;Lpi=0;Lpi_dB=0;distance=0;p1_split=0;p2_split=0;xi=0;
                        BS_UE=0;p1_split_tot=0;p2_split_tot=0;p3_split_tot=0;T=0;
                        Waiting = waitbar(0,'Calculations in progress, please wait...');
                        for i=1:100, % computation here %
                            waitbar(i/100)
                        end
                        [BS_total]=manhattan_env2(building_number_x, building_number_y);
                        [BS_num,n] = size(BS_total);
                        hold on

                        Pt_total=zeros(round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps+360/UE_vel_mps),BS_num);
                        for t_sec=1:round(360/UE_vel_mps-1)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS
                            UE_pos_mul(num,1)=mov_UE_pos(1,1)+UE_vel_mps*t_sec;
                            UE_pos_mul(num,2)=mov_UE_pos(1,2);
                            plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',BS_total(50,1),BS_total(50,2),'g*',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            hold on;

                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                            % from RRM strategies p.143 (162)
                            % Ptj = Transmission power of the jth BS in Watt
                            % Lij = Path Loss to UE i from jth BS
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    xi(j,i)=BS_power/Lpi(j,i);
                                end
                            end

                            for i=1:num         % num = number of all UEs
                                xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                            end

                            BS_UE = ones([num 2]);
                            for i=1:num         % num = number of all UEs
                                BS_UE(i,1) = i;
                                BS_UE(i,2) = BS_act(i);
                            end

                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No_mov*Rb) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end

                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end

                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end
                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(t_sec,1:BS_num)=Pt;
                        end;
                        UE_pos_mul_x=UE_pos_mul(num,1);
                        UE_pos_mul_y=UE_pos_mul(num,2);


                        for t_sec=round(360/UE_vel_mps):round(360/UE_vel_mps+180/UE_vel_mps)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS
                            UE_pos_mul(num,1)=UE_pos_mul_x;
                            UE_pos_mul(num,2)=UE_pos_mul_y+UE_vel_mps*(t_sec-360/UE_vel_mps);
                            plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',BS_total(50,1),BS_total(50,2),'g*',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            hold on;

                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                            % from RRM strategies p.143 (162)
                            % Ptj = Transmission power of the jth BS in Watt
                            % Lij = Path Loss to UE i from jth BS
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    xi(j,i)=BS_power/Lpi(j,i);
                                end
                            end

                            for i=1:num         % num = number of all UEs
                                xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                            end

                            BS_UE = ones([num 2]);
                            for i=1:num         % num = number of all UEs
                                BS_UE(i,1) = i;
                                BS_UE(i,2) = BS_act(i);
                            end

                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No_mov*Rb) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end

                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end

                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end
                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(t_sec,1:BS_num)=Pt;
                        end;
                        UE_pos_mul_x=UE_pos_mul(num,1);
                        UE_pos_mul_y=UE_pos_mul(num,2);

                        for t_sec=round(360/UE_vel_mps+180/UE_vel_mps+1):round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS

                            UE_pos_mul(num,1)=UE_pos_mul_x-UE_vel_mps*(t_sec-360/UE_vel_mps-180/UE_vel_mps);
                            UE_pos_mul(num,2)=UE_pos_mul_y;
                            plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',BS_total(50,1),BS_total(50,2),'g*',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            hold on;

                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                            % from RRM strategies p.143 (162)
                            % Ptj = Transmission power of the jth BS in Watt
                            % Lij = Path Loss to UE i from jth BS
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    xi(j,i)=BS_power/Lpi(j,i);
                                end
                            end

                            for i=1:num         % num = number of all UEs
                                xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                            end

                            BS_UE = ones([num 2]);
                            for i=1:num         % num = number of all UEs
                                BS_UE(i,1) = i;
                                BS_UE(i,2) = BS_act(i);
                            end

                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No_mov*Rb) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end

                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end

                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end
                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(t_sec,1:BS_num)=Pt;
                        end;
                        UE_pos_mul_x=UE_pos_mul(num,1);
                        UE_pos_mul_y=UE_pos_mul(num,2);

                        for t_sec=round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps+1):round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps+360/UE_vel_mps)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS

                            UE_pos_mul(num,1)=UE_pos_mul_x;
                            UE_pos_mul(num,2)=UE_pos_mul_y-UE_vel_mps*(t_sec-(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps));
                            plot(circle_center(1,1)+circle_radius*sin(t),circle_center(1,2)+circle_radius*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',BS_total(50,1),BS_total(50,2),'g*',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            hold on;

                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                            % from RRM strategies p.143 (162)
                            % Ptj = Transmission power of the jth BS in Watt
                            % Lij = Path Loss to UE i from jth BS
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    xi(j,i)=BS_power/Lpi(j,i);
                                end
                            end

                            for i=1:num         % num = number of all UEs
                                xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                            end

                            BS_UE = ones([num 2]);
                            for i=1:num         % num = number of all UEs
                                BS_UE(i,1) = i;
                                BS_UE(i,2) = BS_act(i);
                            end

                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No_mov*Rb) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end

                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end

                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end
                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(t_sec,1:BS_num)=Pt;
                        end;
                        legend('Examined area','Node Bs','Examined Node B','Static UEs','Moving UE route');
                        
                        % Parameters Display
                        Display_message = char(strcat({'--------------------------------------',...
                            'Input Parameters',...
                            '--------------------------------------',...
                            'You have made the following choices:','',...
                            'Number of UEs:',num2str(num),...
                            'Moving UE''s Velocity (Km/h):',num2str(UE_vel),...
                            'Other BSs transmitted power (Watt):',num2str(BS_power),...
                            'Background noise (Watt):',num2str(Pn),...
                            'Common Control Channel power (Watt):',num2str(Pc),...
                            'Eb/No (dB):',num2str(Eb_No_dB_mov),...
                            'Bit rate (kbps):',num2str(Rb_kbps),...
                            'Orthogonallity factor:',num2str(p),'',''}));
                        msgbox(Display_message,'Parameters Display');

                        figure('Name','Examined BS total transmission power vs moving UEs');
                        for time=1:t_sec
                            T(time)=time;
                        end
                        plot(T,Pt_total(:,50),'-');
                        xlabel('Time (sec)'); ylabel('Examined Node B Total Power (W)');
                        grid;
                        close(Waiting)
                    end;

        %******************************************************************
        % Moving UE''s Active BS total power (choise4 == 2)****************
                    if choise4 == 2,
                        close all;

                        Pt=0;Lpi=0;Lpi_dB=0;distance=0;p1_split=0;p2_split=0;xi=0;
                        BS_UE=0;p1_split_tot=0;p2_split_tot=0;p3_split_tot=0;T=0;
                        Waiting = waitbar(0,'Calculations in progress, please wait...');
                        for i=1:100, % computation here %
                            waitbar(i/100)
                        end
                        [BS_total]=manhattan_env2(building_number_x, building_number_y);
                        [BS_num,n] = size(BS_total);
                        hold on

                        Pt_total=zeros(round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps+360/UE_vel_mps),1);
                        UE_pos_mul_x=mov_UE_pos(1,1);
                        UE_pos_mul_y=mov_UE_pos(1,2);
                        for t_sec=1:round(360/UE_vel_mps-1)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS
                            UE_pos_mul(num,1)=UE_pos_mul_x+UE_vel_mps*t_sec;
                            UE_pos_mul(num,2)=UE_pos_mul_y;

                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            plot(BS_total(BS_act(num),1)+(circle_radius+11)*sin(t),BS_total(BS_act(num),2)+(circle_radius+11)*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',...
                                BS_total(BS_act(num),1),BS_total(BS_act(num),2),'*g',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            hold on;
                            % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                            % from RRM strategies p.143 (162)
                            % Ptj = Transmission power of the jth BS in Watt
                            % Lij = Path Loss to UE i from jth BS
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    xi(j,i)=BS_power/Lpi(j,i);
                                end
                            end

                            for i=1:num         % num = number of all UEs
                                xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                            end

                            BS_UE = ones([num 2]);
                            for i=1:num         % num = number of all UEs
                                BS_UE(i,1) = i;
                                BS_UE(i,2) = BS_act(i);
                            end

                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No_mov*Rb) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end

                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end

                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end
                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(t_sec,1)=Pt(BS_act(num));
                        end;
                        UE_pos_mul_x=UE_pos_mul(num,1);
                        UE_pos_mul_y=UE_pos_mul(num,2);

                        for t_sec=round(360/UE_vel_mps):round(360/UE_vel_mps+180/UE_vel_mps)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS
                            UE_pos_mul(num,1)=UE_pos_mul_x;
                            UE_pos_mul(num,2)=UE_pos_mul_y+UE_vel_mps*(t_sec-360/UE_vel_mps);
                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            plot(BS_total(BS_act(num),1)+(circle_radius+11)*sin(t),BS_total(BS_act(num),2)+(circle_radius+11)*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',...
                                BS_total(BS_act(num),1),BS_total(BS_act(num),2),'*g',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            hold on;
                            % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                            % from RRM strategies p.143 (162)
                            % Ptj = Transmission power of the jth BS in Watt
                            % Lij = Path Loss to UE i from jth BS
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    xi(j,i)=BS_power/Lpi(j,i);
                                end
                            end

                            for i=1:num         % num = number of all UEs
                                xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                            end

                            BS_UE = ones([num 2]);
                            for i=1:num         % num = number of all UEs
                                BS_UE(i,1) = i;
                                BS_UE(i,2) = BS_act(i);
                            end

                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No_mov*Rb) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end

                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end

                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end
                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(t_sec,1)=Pt(BS_act(num));
                        end;
                        UE_pos_mul_x=UE_pos_mul(num,1);
                        UE_pos_mul_y=UE_pos_mul(num,2);

                        for t_sec=round(360/UE_vel_mps+180/UE_vel_mps+1):round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS

                            UE_pos_mul(num,1)=UE_pos_mul_x-UE_vel_mps*(t_sec-360/UE_vel_mps-180/UE_vel_mps);
                            UE_pos_mul(num,2)=UE_pos_mul_y;
                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            plot(BS_total(BS_act(num),1)+(circle_radius+11)*sin(t),BS_total(BS_act(num),2)+(circle_radius+11)*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',...
                                BS_total(BS_act(num),1),BS_total(BS_act(num),2),'*g',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            hold on;
                            % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                            % from RRM strategies p.143 (162)
                            % Ptj = Transmission power of the jth BS in Watt
                            % Lij = Path Loss to UE i from jth BS
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    xi(j,i)=BS_power/Lpi(j,i);
                                end
                            end

                            for i=1:num         % num = number of all UEs
                                xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                            end

                            BS_UE = ones([num 2]);
                            for i=1:num         % num = number of all UEs
                                BS_UE(i,1) = i;
                                BS_UE(i,2) = BS_act(i);
                            end

                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No_mov*Rb) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end

                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end

                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end
                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(t_sec,1)=Pt(BS_act(num));
                        end;
                        UE_pos_mul_x=UE_pos_mul(num,1);
                        UE_pos_mul_y=UE_pos_mul(num,2);

                        for t_sec=round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps+1):round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps+360/UE_vel_mps)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS

                            UE_pos_mul(num,1)=UE_pos_mul_x;
                            UE_pos_mul(num,2)=UE_pos_mul_y-UE_vel_mps*(t_sec-(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps));
                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            plot(BS_total(BS_act(num),1)+(circle_radius+11)*sin(t),BS_total(BS_act(num),2)+(circle_radius+11)*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',...
                                BS_total(BS_act(num),1),BS_total(BS_act(num),2),'*g',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            hold on;
                            % Intercell Interference Evaluation {xi_tot = sum(Ptj/Lij)}
                            % from RRM strategies p.143 (162)
                            % Ptj = Transmission power of the jth BS in Watt
                            % Lij = Path Loss to UE i from jth BS
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    xi(j,i)=BS_power/Lpi(j,i);
                                end
                            end

                            for i=1:num         % num = number of all UEs
                                xi_tot(i)=sum(xi(:,i))-xi(BS_act(i),i);
                            end

                            BS_UE = ones([num 2]);
                            for i=1:num         % num = number of all UEs
                                BS_UE(i,1) = i;
                                BS_UE(i,2) = BS_act(i);
                            end

                            p1_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p1_split(j,i) = W/(Eb_No_mov*Rb) + p;
                                    else p1_split(j,i) = 0;
                                    end
                                end
                            end

                            p2_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p2_split(j,i) = (Pn+xi_tot(i))*Lpi_act(i)/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end

                            p3_split=zeros(BS_num,num);
                            for j=1:BS_num      % BS_num = number of all BSs
                                for i=1:num % num = number of all UEs
                                    if j==BS_UE(i,2)% to find UE that have the BSj to Active set
                                        p3_split(j,i) = p/p1_split(j,i);
                                    else p2_split(j,i) = 0;
                                    end
                                end
                            end
                            p1_split_tot=(max(p1_split'));
                            p2_split_tot=(sum(p2_split'));
                            p3_split_tot=(sum(p3_split'));

                            Pt = (Pc+p2_split_tot)./(1-p3_split_tot);
                            Pt_total(t_sec,1)=Pt(BS_act(num));
                        end;
                        legend('New Active Node B''s Range','Node Bs','Moving UE''s Active Node B','Static UEs','Moving UE''s route');

                        % Parameters Display
                        Display_message = char(strcat({'--------------------------------------',...
                            'Input Parameters',...
                            '--------------------------------------',...
                            'You have made the following choices:','',...
                            'Number of UEs:',num2str(num),...
                            'Moving UE''s Velocity (Km/h):',num2str(UE_vel),...
                            'Other BSs transmitted power (Watt):',num2str(BS_power),...
                            'Background noise (Watt):',num2str(Pn),...
                            'Common Control Channel power (Watt):',num2str(Pc),...
                            'Eb/No (dB):',num2str(Eb_No_dB_mov),...
                            'Bit rate (kbps):',num2str(Rb_kbps),...
                            'Orthogonallity factor:',num2str(p),'',''}));
                        msgbox(Display_message,'Parameters Display');

                        figure('Name','Moving UE''s Active BS total power');
                        for time=1:t_sec
                            T(time)=time;
                        end
                        plot(T,Pt_total,'-');
                        xlabel('Time (sec)'); ylabel('Moving UE''s Active BS total power (W)');
                        grid;
                        close(Waiting)
                    end;

        %******************************************************************
        % Video Creation for Specified Topology (choise4 == 3)*************
                    if choise4 == 3,
                        close all;

                        Pt=0;Lpi=0;Lpi_dB=0;distance=0;xi=0;UE_pos_mul_x=0;
                        UE_pos_mul_y=0;BS_UE=0;aviobj=0;Lpi_act=0;BS_act=0;T=0;
                        [BS_total]=manhattan_env2(building_number_x, building_number_y);
                        [BS_num,n] = size(BS_total);
                        hold on
                        UE_pos_mul_x=mov_UE_pos(1,1);
                        UE_pos_mul_y=mov_UE_pos(1,2);
                        avi_name = char(strcat({' Video Name (eg. my_video.avi)'}));
                        prompt = {avi_name};
                        title  = 'Video Creation';
                        def    = {m_aviname};
                        answer = inputdlg(prompt,title,lines,def);
                        aviname = answer(1);
                        if (isempty(aviname)) aviname=m_aviname; end
                        aviobj = avifile(char(aviname),'fps',5);

                        for t_sec=1:round(360/UE_vel_mps-1)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS
                            UE_pos_mul(num,1)=UE_pos_mul_x+UE_vel_mps*t_sec;
                            UE_pos_mul(num,2)=UE_pos_mul_y;

                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            h=plot(BS_total(BS_act(num),1)+(circle_radius+11)*sin(t),BS_total(BS_act(num),2)+(circle_radius+11)*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',...
                                BS_total(BS_act(num),1),BS_total(BS_act(num),2),'*g',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            legend('New Active Node B''s Range','Node Bs','Moving UE''s Active Node B','Static UEs','Moving UE''s route');
                            axis equal;
                            frame = getframe(gca);
                            aviobj = addframe(aviobj,frame);
                        end;
                        UE_pos_mul_x=UE_pos_mul(num,1);
                        UE_pos_mul_y=UE_pos_mul(num,2);

                        for t_sec=round(360/UE_vel_mps):round(360/UE_vel_mps+180/UE_vel_mps)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS
                            UE_pos_mul(num,1)=UE_pos_mul_x;
                            UE_pos_mul(num,2)=UE_pos_mul_y+UE_vel_mps*(t_sec-360/UE_vel_mps);
                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            h=plot(BS_total(BS_act(num),1)+(circle_radius+11)*sin(t),BS_total(BS_act(num),2)+(circle_radius+11)*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',...
                                BS_total(BS_act(num),1),BS_total(BS_act(num),2),'*g',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            legend('New Active Node B''s Range','Node Bs','Moving UE''s Active Node B','Static UEs','Moving UE''s route');
                            axis equal;
                            frame = getframe(gca);
                            aviobj = addframe(aviobj,frame);
                        end;
                        UE_pos_mul_x=UE_pos_mul(num,1);
                        UE_pos_mul_y=UE_pos_mul(num,2);

                        for t_sec=round(360/UE_vel_mps+180/UE_vel_mps+1):round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS

                            UE_pos_mul(num,1)=UE_pos_mul_x-UE_vel_mps*(t_sec-360/UE_vel_mps-180/UE_vel_mps);
                            UE_pos_mul(num,2)=UE_pos_mul_y;
                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            h=plot(BS_total(BS_act(num),1)+(circle_radius+11)*sin(t),BS_total(BS_act(num),2)+(circle_radius+11)*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',...
                                BS_total(BS_act(num),1),BS_total(BS_act(num),2),'*g',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            legend('New Active Node B''s Range','Node Bs','Moving UE''s Active Node B','Static UEs','Moving UE''s route');
                            axis equal;
                            frame = getframe(gca);
                            aviobj = addframe(aviobj,frame);
                        end;
                        UE_pos_mul_x=UE_pos_mul(num,1);
                        UE_pos_mul_y=UE_pos_mul(num,2);

                        for t_sec=round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps+1):round(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps+360/UE_vel_mps)
                            % Path Loss Evaluation {Lpi_dB = 24 + 45*log(distance + 20) in dBs}
                            % from RRM strategies p.295 (314)
                            % distance = distance in meters between UE and each BS

                            UE_pos_mul(num,1)=UE_pos_mul_x;
                            UE_pos_mul(num,2)=UE_pos_mul_y-UE_vel_mps*(t_sec-(360/UE_vel_mps+180/UE_vel_mps+180/UE_vel_mps));
                            % Evaluation of UE-BS distance (in meters)
                            for i=1:num         % num = number of all UEs
                                for j=1:BS_num  % BS_num = number of all BSs
                                    distance(j,i)=sqrt((BS_total(j,1)-UE_pos_mul(i,1)).^2+(BS_total(j,2)-UE_pos_mul(i,2)).^2);
                                end
                            end                            

                            % Total Path Loss Evaluation
                            for i=1:num
                                for j=1:BS_num  % BS_num = number of all BSs
                                    Lpi_dB(j,i)=24+45*log10(distance(j,i)+20);
                                    Lpi(j,i)=10^(Lpi_dB(j,i)/10);
                                end
                            end

                            % Path Loss from active BS (closest to UE)
                            for i=1:num         % num = number of all UEs
                                [Lpi_act(i),BS_act(i)]=min(Lpi(:,i));
                            end

                            h=plot(BS_total(BS_act(num),1)+(circle_radius+11)*sin(t),BS_total(BS_act(num),2)+(circle_radius+11)*cos(t),...
                                BS_total(:,1),BS_total(:,2),'b*',...
                                BS_total(BS_act(num),1),BS_total(BS_act(num),2),'*g',...
                                UE_pos_mul(1:num-1,1),UE_pos_mul(1:num-1,2),'r.',...
                                UE_pos_mul(num,1),UE_pos_mul(num,2),'ko','MarkerFaceColor','k');
                            legend('New Active Node B''s Range','Node Bs','Moving UE''s Active Node B','Static UEs','Moving UE''s route');
                            axis equal;
                            frame = getframe(gca);
                            aviobj = addframe(aviobj,frame);
                        end;
                        aviobj = close(aviobj);

                    end;

        %******************************************************************
        % Help Window (choise4 == 4)***************************************
                    if choise4 == 4,
                        clc;
                        close all;
                        open('Help_5.pdf');
                    end;

        %******************************************************************
        % Close Submenu (choise4 == 5)*************************************
                    if choise4 == possibility4
                        close all;
                    end;

                end;
            end;

% *************************************************************************
    % Help Window (choise1 == 4)*******************************************
            if choise1 == 4,
                clc;
                close all;
                open('Help_2.pdf');
            end

% *************************************************************************
    % Close Submenu (choise1 == 5)*****************************************
            if choise1 == possibility1
                close all;
            end
        end;

    end;


% *************************************************************************
% *************************************************************************
    % Help Window (choise == 4)********************************************
    if choise == 4,
        clc;
        close all;
        open('Help_1.pdf');

    end;


% *************************************************************************
% *************************************************************************
    % Credits (choise == 5)************************************************
    if choise == 5,
        clc;
        close all;
        % Parameters Display
        Display_message = char(strcat({
            '------------------------------------------------------------------',...
            '------------------------------------------------------------------',...
            'Christos Bouras, Associate Professor',...
            'Department of Computer Engineering and Informatics, Univ. of Patras',...
            'Research Academic Computer Technology Institute',...
            'GR-26500 Rion, PATRA, GREECE',...
            'e-mail: bouras@cti.gr, bouras@ceid.upatras.gr',...
            'URL:ru6.cti.gr/bouras Skype ID: christos.bouras',...
            'Tel.: +30 261 0 960375, +30 261 0 996951',...
            'Mob.: +30 6944988434',...
            'Fax : +30-2610-969016',...
            '------------------------------------------------------------------',...
            'Basileios G. Kokkinos',...
            'Physicist, M.Sc.',...
            'Research Academic Computer Technology Institute',...
            'Research Unit 6 and',...
            'Computer Engineering and Informatics Dept, Univ. of Patras',...
            'Patra  Greece',...
            'e-mail: kokkinos@cti.gr',...
            'Tel.: +30 261 0 996954   Mob.: +30 6936755728',...
            'Fax : +30 261 0 960358',...
            '------------------------------------------------------------------',...
            'Evangelos G. Rekkas',...
            'Undergraduate Student of',...
            'Computer Engineering and Informatics Dept, Univ. of Patras and',...
            'Research Academic Computer Technology Institute',...
            'Research Unit 6',...
            'Patra  Greece',...
            'e-mail: rekkas@cti.gr',...
            'Tel.: +30 261 0 996954   Mob.: +30 6977571964',...
            'Fax : +30 261 0 960358',...
            '------------------------------------------------------------------',...
            'Antonios G. Alexiou',...
            'Electrical and Computer Engineer, PhD',...
            'Research Academic Computer Technology Institute',...
            'Research Unit 6 and',...
            'Computer Engineering and Informatics Dept, Univ. of Patras',...
            'Patra  Greece',...
            'e-mail: alexiua@cti.gr',...
            'URL: http://ru6.cti.gr/users/antonis/',...
            'Tel.: +30 261 0 960316   Mob.:+30 6942066466',...
            'Fax : +30 261 0 960358',...
            '------------------------------------------------------------------',...
            '------------------------------------------------------------------'}));

        msgbox(Display_message,'Credits');

    end;


% *************************************************************************
% *************************************************************************
    % Close Program (choise == 6)******************************************
    if choise == possibility

        close all;
    end;
end;

% *************************************************************************
% *************************************************************************
% *************************************************************************
% *************************************************************************
% *************************************************************************