function [BS_total]=manhattan_env1(building_number_x,building_number_y)

% Topology values
road_width=15;
road_lenght=15;
building_width=75;
building_length=75;
total_length=road_lenght+building_number_x*(road_lenght+building_length);
total_width=road_width+building_number_y*(road_width+building_width);
manh_grid=figure('Name','Manchattan Grid Environment');
xlabel('x-direction (m) --> '); ylabel('y-direction (m) --> ');
hold on
for x=1:building_number_x
    for y=1:building_number_y
        rectangle('Position',[x*road_lenght+(x-1)*building_length,...
            y*road_width+(y-1)*building_width,building_length,...
            building_width],'FaceColor',[0.7 0.7 0.7])
    end
end
hold on

% Base Station Topology
% Initial Matrixes
BS1 = ones([building_number_x*building_number_y/16 2]);
BS2 = ones([building_number_x*building_number_y/16 2]);
BS3 = ones([building_number_x*building_number_y/16 2]);
BS4 = ones([building_number_x*building_number_y/16 2]);
BS5 = ones([building_number_x*building_number_y/16 2]);
BS6 = ones([building_number_x*building_number_y/16 2]);
BS7 = ones([building_number_x*building_number_y/16 2]);
BS8 = ones([building_number_x*building_number_y/16 2]);
BS_total = ones([building_number_x*building_number_y/2 2]);

% Create the topology for the first cell
for x=1:(building_number_x/4) %
    for y=1:(building_number_y/4)
        BS1(x,1) = road_lenght/2+4*(x-1)*(road_lenght+building_length);
        BS1(y,2) = road_width+building_width/2+4*(y-1)*(road_width+building_width);
        BS2(x,1) = 3*road_lenght+5*building_length/2+4*(x-1)*(road_lenght+building_length);
        BS2(y,2) = 3*road_width/2+building_width+4*(y-1)*(road_width+building_width);
        BS3(x,1) = 2*road_lenght+3*building_length/2+4*(x-1)*(road_lenght+building_length);
        BS3(y,2) = road_width/2+4*(y-1)*(road_width+building_width);
        BS4(x,1) = 3*road_lenght/2+building_length+4*(x-1)*(road_lenght+building_length);
        BS4(y,2) = 2*road_width+3*building_width/2+4*(y-1)*(road_width+building_width);
        BS5(x,1) = road_lenght+building_length/2+4*(x-1)*(road_lenght+building_length);
        BS5(y,2) = 7*road_width/2+3*building_width+4*(y-1)*(road_width+building_width);
        BS6(x,1) = 5*road_lenght/2+2*building_length+4*(x-1)*(road_lenght+building_length);
        BS6(y,2) = 3*road_width+5*building_width/2+4*(y-1)*(road_width+building_width);
        BS7(x,1) = 7*road_lenght/2+3*building_length+4*(x-1)*(road_lenght+building_length);
        BS7(y,2) = 4*road_width+7*building_width/2+4*(y-1)*(road_width+building_width);
        BS8(x,1) = 4*road_lenght+7*building_length/2+4*(x-1)*(road_lenght+building_length);
        BS8(y,2) = 5*road_width/2+2*building_width+4*(y-1)*(road_width+building_width);
    end
end

% Create the topology depending on the number of buildings
for j=1:building_number_x/4
    BS1((building_number_x/4-j)*building_number_y/4+1:(building_number_x/4-j+1)*building_number_y/4,1) = BS1(building_number_x/4-j+1,1);
    BS1((j-1)*building_number_y/4+1:j*building_number_y/4,2) = BS1(1:building_number_y/4,2);
    BS2((building_number_x/4-j)*building_number_y/4+1:(building_number_x/4-j+1)*building_number_y/4,1) = BS2(building_number_x/4-j+1,1);
    BS2((j-1)*building_number_y/4+1:j*building_number_y/4,2) = BS2(1:building_number_y/4,2);
    BS3((building_number_x/4-j)*building_number_y/4+1:(building_number_x/4-j+1)*building_number_y/4,1) = BS3(building_number_x/4-j+1,1);
    BS3((j-1)*building_number_y/4+1:j*building_number_y/4,2) = BS3(1:building_number_y/4,2);
    BS4((building_number_x/4-j)*building_number_y/4+1:(building_number_x/4-j+1)*building_number_y/4,1) = BS4(building_number_x/4-j+1,1);
    BS4((j-1)*building_number_y/4+1:j*building_number_y/4,2) = BS4(1:building_number_y/4,2);
    BS5((building_number_x/4-j)*building_number_y/4+1:(building_number_x/4-j+1)*building_number_y/4,1) = BS5(building_number_x/4-j+1,1);
    BS5((j-1)*building_number_y/4+1:j*building_number_y/4,2) = BS5(1:building_number_y/4,2);
    BS6((building_number_x/4-j)*building_number_y/4+1:(building_number_x/4-j+1)*building_number_y/4,1) = BS6(building_number_x/4-j+1,1);
    BS6((j-1)*building_number_y/4+1:j*building_number_y/4,2) = BS6(1:building_number_y/4,2);
    BS7((building_number_x/4-j)*building_number_y/4+1:(building_number_x/4-j+1)*building_number_y/4,1) = BS7(building_number_x/4-j+1,1);
    BS7((j-1)*building_number_y/4+1:j*building_number_y/4,2) = BS7(1:building_number_y/4,2);
    BS8((building_number_x/4-j)*building_number_y/4+1:(building_number_x/4-j+1)*building_number_y/4,1) = BS8(building_number_x/4-j+1,1);
    BS8((j-1)*building_number_y/4+1:j*building_number_y/4,2) = BS8(1:building_number_y/4,2);
end

% Total BSs topology
BS_total(1:building_number_x*building_number_y/16,:)=BS1;
BS_total(building_number_x*building_number_y/16+1:2*building_number_x*building_number_y/16,:)=BS2;
BS_total(2*building_number_x*building_number_y/16+1:3*building_number_x*building_number_y/16,:)=BS3;
BS_total(3*building_number_x*building_number_y/16+1:4*building_number_x*building_number_y/16,:)=BS4;
BS_total(4*building_number_x*building_number_y/16+1:5*building_number_x*building_number_y/16,:)=BS5;
BS_total(5*building_number_x*building_number_y/16+1:6*building_number_x*building_number_y/16,:)=BS6;
BS_total(6*building_number_x*building_number_y/16+1:7*building_number_x*building_number_y/16,:)=BS7;
BS_total(7*building_number_x*building_number_y/16+1:8*building_number_x*building_number_y/16,:)=BS8;

% % Depict the BSs on image
% [m,n] = size(BS_total);
% for i=1:m       % m = number of all BSs
%     plot(BS_total(i,1),BS_total(i,2),'*');hold on;
% end